VERSION 5.00
Begin VB.Form frmVirKey 
   Caption         =   "Cdigos de tecla"
   ClientHeight    =   5400
   ClientLeft      =   60
   ClientTop       =   348
   ClientWidth     =   4152
   Icon            =   "VirKey.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   5400
   ScaleWidth      =   4152
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txbKeyHistory 
      Height          =   2505
      Left            =   240
      MaxLength       =   64000
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   6
      Text            =   "VirKey.frx":030A
      Top             =   2580
      Width           =   3615
   End
   Begin VB.Frame fraKeyCode 
      Caption         =   "Cdigo de tecla (Hex) && carcter"
      Height          =   1425
      Left            =   240
      TabIndex        =   3
      Top             =   120
      Width           =   3615
      Begin VB.CheckBox ckbDetectShiftAlone 
         Caption         =   "Detecta SHIFT"
         Height          =   195
         Left            =   180
         TabIndex        =   5
         Top             =   1020
         Width           =   2475
      End
      Begin VB.Label lblVirtualKey 
         Alignment       =   2  'Center
         BackColor       =   &H00000000&
         BorderStyle     =   1  'Fixed Single
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H0000C000&
         Height          =   405
         Left            =   150
         TabIndex        =   4
         Top             =   390
         Width           =   3375
      End
   End
   Begin VB.Timer Timer1 
      Interval        =   10
      Left            =   480
      Top             =   360
   End
   Begin VB.Shape Shape1 
      Height          =   405
      Left            =   270
      Top             =   1710
      Width           =   3585
   End
   Begin VB.Label lblNumLock 
      Caption         =   "lblNumLock"
      Height          =   285
      Left            =   450
      TabIndex        =   2
      Top             =   1800
      Width           =   1095
   End
   Begin VB.Label lblScrollLock 
      Caption         =   "lblScrollLock"
      Height          =   285
      Left            =   2790
      TabIndex        =   1
      Top             =   1800
      Width           =   1005
   End
   Begin VB.Label lblCapsLock 
      Caption         =   "lblCapsLock"
      Height          =   285
      Left            =   1650
      TabIndex        =   0
      Top             =   1800
      Width           =   945
   End
End
Attribute VB_Name = "frmVirKey"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' VirKey.frm
'
' By Herman Liu
'
' To obtain virtual key codes including TAB and SHIFT etc.  When a keyboard Key, or a
' combination of Shift+Key is hit, the character and its virtual key code are displayed.
' The code is capable of distinguishing upper and lower cases (if a lower case, the
' normal ascii code is shown).   This is done (1) without setting Keypreview property of
' the form, (2) without subclass hooking and (3) without using a third party OCX.

Option Explicit

Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128   '  Maintenance string for PSS usage
End Type

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" _
    (lpVersionInformation As OSVERSIONINFO) As Long
Private Declare Sub keybd_event Lib "user32" (ByVal bVk As Byte, ByVal bScan As Byte, _
    ByVal dwFlags As Long, ByVal dwExtraInfo As Long)
Private Declare Function GetKeyboardState Lib "user32" (pbKeyState As Byte) As Long
Private Declare Function SetKeyboardState Lib "user32" (lppbKeyState As Byte) As Long
Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer

Const VK_SHIFT = &H10
Const VK_CONTROL = &H11
Const VK_CAPITAL = &H14
Const VK_NUMLOCK = &H90
Const VK_SCROLL = &H91
Const KEYEVENTF_EXTENDEDKEY = &H1
Const KEYEVENTF_KEYUP = &H2
Const VER_PLATFORM_WIN32_NT = 2
Const VER_PLATFORM_WIN32_WINDOWS = 1

' Note  VK_A to VK_Z, and VK_0 to VK_9 are the same as their ASCII

'-----------------------------------------------------------------------------
  ' The following are listed for reference only, not being used here
Private Const VK_LBUTTON = &H1
Private Const VK_RBUTTON = &H2
Private Const VK_CANCEL = &H3
Private Const VK_MBUTTON = &H4
Private Const VK_CLEAR = &HC
Private Const VK_PRIOR = &H21
Private Const VK_SELECT = &H29
Private Const VK_PRINT = &H2A
Private Const VK_EXECUTE = &H2B
Private Const VK_SNAPSHOT = &H2C
Private Const VK_HELP = &H2F
Private Const VK_SEPARATOR = &H6C
  ' VK_L VK_R - used only in GetAsyncKeyState() and GetKeyState()
Private Const VK_LSHIFT = &HA0
Private Const VK_RSHIFT = &HA1
Private Const VK_LCONTROL = &HA2
Private Const VK_RCONTROL = &HA3
Private Const VK_LMENU = &HA4              ' Left ALT
Private Const VK_RMENU = &HA5
Private Const VK_ATTN = &HF6
Private Const VK_CRSEL = &HF7
Private Const VK_EXSEL = &HF8
Private Const VK_EREOF = &HF9
Private Const VK_PLAY = &HFA
Private Const VK_ZOOM = &HFB
Private Const VK_NONAME = &HFC
Private Const VK_PA1 = &HFD
Private Const VK_OEM_CLEAR = &HFE
'-----------------------------------------------------------------

Const IsTrue = -32767
Dim WinVer As Long
Dim ShiftOn As Boolean
Dim vKey As Long



Private Sub Form_Load()
    Dim OSVer As OSVERSIONINFO
    OSVer.dwOSVersionInfoSize = Len(OSVer)
    WinVer = GetVersionEx(OSVer)
    
    txbKeyHistory.Text = ""
    
       ' We default this
    ckbDetectShiftAlone.Value = 0
       ' Clear Shift state if on.
    If KeyStatus(VK_SHIFT) Then
         ToggleState VK_SHIFT
    End If
    ShiftOn = False
      ' Display current states of NUM, CAPS & SCROLL Locks
    If KeyStatus(VK_NUMLOCK) Then
        lblNumLock.Caption = "Num = On"
    Else
        lblNumLock.Caption = "Num = Off"
    End If
    If KeyStatus(VK_CAPITAL) Then
        lblCapsLock.Caption = "Cap = On"
    Else
        lblCapsLock.Caption = "Cap = Off"
    End If
    If KeyStatus(VK_SCROLL) Then
        lblScrollLock.Caption = "Scroll = On"
    Else
        lblScrollLock.Caption = "Scroll = Off"
    End If
End Sub



Private Sub ckbDetectShiftAlone_Click()
    If ckbDetectShiftAlone.Value = 1 Then
        If KeyStatus(VK_SHIFT) Then
             ShiftOn = True
        Else
             ShiftOn = False
        End If
    Else
          ' Clear Shift state if on.
        If KeyStatus(VK_SHIFT) Then
             ToggleState VK_SHIFT
        End If
        ShiftOn = False
    End If
End Sub



Private Sub Timer1_Timer()
    Dim KeyDisp As String
    DoEvents
    KeyDisp = ""
    
    If GetAsyncKeyState(&H8) = IsTrue Then
        KeyDisp = "8     [BKSPACE]"
    ElseIf GetAsyncKeyState(&H9&) = IsTrue Then
        KeyDisp = "9     [TAB]"
    ElseIf GetAsyncKeyState(&HD&) = IsTrue Then
        KeyDisp = "0D     [ENTER]"
    ElseIf GetAsyncKeyState(&H11) = IsTrue Then
        KeyDisp = "11     [CTRL]"
    ElseIf GetAsyncKeyState(&H12) = IsTrue Then           ' VK_MENU
        KeyDisp = "12     [ALT]"
    ElseIf GetAsyncKeyState(&H13) = IsTrue Then
        KeyDisp = "13     [PAUSE]"
    ElseIf GetAsyncKeyState(&H14) = IsTrue Then           ' VK_CAPITAL
        KeyDisp = "14     [Caps Lock]"
        If lblCapsLock.Caption = "Cap = On" Then
             lblCapsLock.Caption = "Cap = Off"
        Else
             lblCapsLock.Caption = "Cap = On"
        End If
    ElseIf GetAsyncKeyState(&H1B&) = IsTrue Then
        KeyDisp = "1B     [ESC]"
    ElseIf GetAsyncKeyState(&H20) = IsTrue Then
        KeyDisp = "20     [SPACE]"
    ElseIf GetAsyncKeyState(&H21) = IsTrue Then
        KeyDisp = "21     [PGUP]"
    ElseIf GetAsyncKeyState(&H22) = IsTrue Then
        KeyDisp = "22     [PGDN]"
    ElseIf GetAsyncKeyState(&H23) = IsTrue Then
        KeyDisp = "23     [END]"
    ElseIf GetAsyncKeyState(&H24) = IsTrue Then
        KeyDisp = "24     [HOME]"
    ElseIf GetAsyncKeyState(&H25) = IsTrue Then
        KeyDisp = "25     [LEFT]"
    ElseIf GetAsyncKeyState(&H26) = IsTrue Then
        KeyDisp = "26     [UP]"
    ElseIf GetAsyncKeyState(&H27) = IsTrue Then
        KeyDisp = "27     [RIGHT]"
    ElseIf GetAsyncKeyState(&H28) = IsTrue Then
        KeyDisp = "28     [DOWN]"
    ElseIf GetAsyncKeyState(&H2D&) = IsTrue Then
        KeyDisp = "2D     [INS]"
    ElseIf GetAsyncKeyState(&H2E&) = IsTrue Then
        KeyDisp = "2E     [DEL]"
        
    ElseIf GetAsyncKeyState(&H5B&) = IsTrue Then
        KeyDisp = "5B     [A short cut]"
    ElseIf GetAsyncKeyState(&H5C&) = IsTrue Then
        KeyDisp = "5C     [A short cut]"
    ElseIf GetAsyncKeyState(&H5D&) = IsTrue Then
        KeyDisp = "5D     [A short cut]"
        
    ElseIf GetAsyncKeyState(&H60) = IsTrue Then
        KeyDisp = "60     Num Pad 0"
    ElseIf GetAsyncKeyState(&H61) = IsTrue Then
        KeyDisp = "61     Num Pad 1"
    ElseIf GetAsyncKeyState(&H62) = IsTrue Then
        KeyDisp = "62     Num Pad 2"
    ElseIf GetAsyncKeyState(&H63) = IsTrue Then
        KeyDisp = "63     Num Pad 3"
    ElseIf GetAsyncKeyState(&H64) = IsTrue Then
        KeyDisp = "64     Num Pad 4"
    ElseIf GetAsyncKeyState(&H65) = IsTrue Then
        KeyDisp = "65     Num Pad 5"
    ElseIf GetAsyncKeyState(&H66) = IsTrue Then
        KeyDisp = "66     Num Pad 6"
    ElseIf GetAsyncKeyState(&H67) = IsTrue Then
        KeyDisp = "67     Num Pad 7"
    ElseIf GetAsyncKeyState(&H68) = IsTrue Then
        KeyDisp = "68     Num Pad 8"
    ElseIf GetAsyncKeyState(&H69) = IsTrue Then
        KeyDisp = "69     Num Pad 9"
    ElseIf GetAsyncKeyState(&H6A&) = IsTrue Then
        KeyDisp = "6A     Num Pad *"
    ElseIf GetAsyncKeyState(&H6B&) = IsTrue Then
        KeyDisp = "6B     Num Pad +"
    ElseIf GetAsyncKeyState(&H6D&) = IsTrue Then
        KeyDisp = "6D     Num Pad -"
    ElseIf GetAsyncKeyState(&H6E&) = IsTrue Then
        KeyDisp = "6E     Num Pad ."
    ElseIf GetAsyncKeyState(&H6F&) = IsTrue Then
        KeyDisp = "6F     Num Pad /"
    ElseIf GetAsyncKeyState(&H70) = IsTrue Then
        KeyDisp = "70     [F1]"
    ElseIf GetAsyncKeyState(&H71) = IsTrue Then
        KeyDisp = "71     [F2]"
    ElseIf GetAsyncKeyState(&H72) = IsTrue Then
        KeyDisp = "72     [F3]"
    ElseIf GetAsyncKeyState(&H73) = IsTrue Then
        KeyDisp = "73     [F4]"
    ElseIf GetAsyncKeyState(&H74) = IsTrue Then
        KeyDisp = "74     [F5]"
    ElseIf GetAsyncKeyState(&H75) = IsTrue Then
        KeyDisp = "75     [F6]"
    ElseIf GetAsyncKeyState(&H76) = IsTrue Then
        KeyDisp = "76     [F7]"
    ElseIf GetAsyncKeyState(&H77) = IsTrue Then
        KeyDisp = "77     [F8]"
    ElseIf GetAsyncKeyState(&H78) = IsTrue Then
        KeyDisp = "78     [F9]"
    ElseIf GetAsyncKeyState(&H79) = IsTrue Then
        KeyDisp = "79     [F10]"
    ElseIf GetAsyncKeyState(&H7A&) = IsTrue Then
        KeyDisp = "7A     [F11]"
    ElseIf GetAsyncKeyState(&H7B&) = IsTrue Then
        KeyDisp = "7B     [F12]"
    ElseIf GetAsyncKeyState(&H90) = IsTrue Then
        KeyDisp = "90     [Num Lock]"
        If lblNumLock.Caption = "Num = On" Then
            lblNumLock.Caption = "Num = Off"
        Else
            lblNumLock.Caption = "Num = On"
        End If
    ElseIf GetAsyncKeyState(&H91) = IsTrue Then
        KeyDisp = "91     [Scroll Lock]"
        If lblScrollLock.Caption = "Scroll = On" Then
            lblScrollLock.Caption = "Scroll = Off"
        Else
            lblScrollLock.Caption = "Scroll = On"
        End If
    End If
    
    If Len(KeyDisp) > 0 Then
        GoTo Done
    End If
    
    For vKey = 33 To 256
        If GetAsyncKeyState(vKey) = IsTrue Then
              '------------------------------------------------------------------------
              ' If we have to check SHIFT state alone, then we don't distinguish cases
              '------------------------------------------------------------------------
            If ckbDetectShiftAlone.Value = 1 Then
                If vKey = &HBA& Then
                     KeyDisp = "BA     :"
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                ElseIf vKey = &HBB& Then
                     KeyDisp = "BB     +"
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                ElseIf vKey = &HBC& Then
                     KeyDisp = "BC     <"
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                ElseIf vKey = &HBD& Then
                     KeyDisp = "BD     _"
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                ElseIf vKey = &HBE& Then
                     KeyDisp = "BE     >"
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                ElseIf vKey = &HBF& Then
                     KeyDisp = "BF     ?"
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                ElseIf vKey = &HC0& Then
                     KeyDisp = "C0     `"
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                ElseIf vKey = &HDB& Then
                     KeyDisp = "DB     {"
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                ElseIf vKey = &HDC& Then
                     KeyDisp = "DC     |"
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                ElseIf vKey = &HDD& Then
                     KeyDisp = "DD     }"
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                ElseIf vKey = &HDE& Then
                     KeyDisp = "DE    " & """"
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                ElseIf vKey = &HFF& Then
                     KeyDisp = "FF     [Fn]"
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                Else
                     KeyDisp = DecToHexStr(vKey) & Space(5) & Chr(vKey)
                     lblVirtualKey.Caption = KeyDisp
                     txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                End If
                
             '------------------------------------------------------------------------
             ' If we are NOT to detect a single SHIFT, then we perform the following
             ' to show appropriate case.  For low case, normal "(ASCII)" is shown.
             '------------------------------------------------------------------------
            Else
                  ' For A-Z
                If vKey >= 65 And vKey <= 90 Then
                    If KeyStatus(VK_SHIFT) Then
                         KeyDisp = DecToHexStr(vKey) & Space(5) & Chr(vKey)
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                    Else
                         KeyDisp = DecToHexStr(vKey + 32) & "(ASCII)" & Space(5) & _
                               Chr(vKey + 32)
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                    End If
                  '-------------------------------------------------------------------
                  ' For 0-9. Note: (1) With normal keyboard, 0-9 are display without
                  ' SHIFT (the opposite) (The same for "-" & "=" later). (2) "-" & "="
                  ' are displayed indiscrimately under virtual key scheme.
                  '-------------------------------------------------------------------
                ElseIf vKey >= 48 And vKey <= 57 Then
                    If KeyStatus(VK_SHIFT) Then
                         Select Case vKey
                             Case 48
                                 KeyDisp = DecToHexStr(41) & "(ASCII)" & Space(5) & ")"
                             Case 49
                                 KeyDisp = DecToHexStr(33) & "(ASCII)" & Space(5) & "!"
                             Case 50
                                 KeyDisp = DecToHexStr(64) & "(ASCII)" & Space(5) & "@"
                             Case 51
                                 KeyDisp = DecToHexStr(35) & "(ASCII)" & Space(5) & "#"
                             Case 52
                                 KeyDisp = DecToHexStr(36) & "(ASCII)" & Space(5) & "$"
                             Case 53
                                 KeyDisp = DecToHexStr(37) & "(ASCII)" & Space(5) & "%"
                             Case 54
                                 KeyDisp = DecToHexStr(94) & "(ASCII)" & Space(5) & "^"
                             Case 55    'Ampersand, hence "&&", otherwise "_" would be shown
                                 KeyDisp = DecToHexStr(38) & "(ASCII)" & Space(5) & "&&"
                             Case 56
                                 KeyDisp = DecToHexStr(42) & "(ASCII)" & Space(5) & "*"
                             Case 57
                                 KeyDisp = DecToHexStr(40) & "(ASCII)" & Space(5) & "("
                         End Select
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                     Else
                         KeyDisp = DecToHexStr(vKey) & Space(5) & Chr(vKey)
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                     End If
                 '---------------------------------------------------------------------
                 ' The following are yet other non-functional keyboard keys which would
                 ' otherwise be of a different case if SHIFT is not pressed.  In order
                 ' to display them correctly, we test the state of SHFIT key.
                 '---------------------------------------------------------------------
                ElseIf vKey = &HBA& Then
                     If KeyStatus(VK_SHIFT) Then
                           ' As before
                         KeyDisp = "BA     :"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                     Else
                         KeyDisp = DecToHexStr(59) & "(ASCII)" & Space(5) & ";"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                     End If
                ElseIf vKey = &HBB& Then
                      ' See comment in 0-9 (opposite)
                    If KeyStatus(VK_SHIFT) Then
                         KeyDisp = "BB     +"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                    Else
                         KeyDisp = DecToHexStr(43) & "(ASCII)" & Space(5) & "="
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                    End If
                ElseIf vKey = &HBC& Then
                    If KeyStatus(VK_SHIFT) Then
                         KeyDisp = "BC     <"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                    Else
                         KeyDisp = DecToHexStr(44) & "(ASCII)" & Space(5) & ","
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                    End If
                ElseIf vKey = &HBD& Then
                      ' See comment in 0-9 (opposite)
                    If KeyStatus(VK_SHIFT) Then
                         KeyDisp = "BD     _"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                    Else
                         KeyDisp = DecToHexStr(95) & "(ASCII)" & Space(5) & "-"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                    End If
                ElseIf vKey = &HBE& Then
                    If KeyStatus(VK_SHIFT) Then
                         KeyDisp = "BE     >"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                    Else
                         KeyDisp = DecToHexStr(46) & "(ASCII)" & Space(5) & "."
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                    End If
                ElseIf vKey = &HBF& Then
                    If KeyStatus(VK_SHIFT) Then
                         KeyDisp = "BF     ?"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                    Else
                         KeyDisp = DecToHexStr(47) & "(ASCII)" & Space(5) & "/"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                    End If
                ElseIf vKey = &HC0& Then
                    If KeyStatus(VK_SHIFT) Then
                         KeyDisp = "C0     ~"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                    Else
                         KeyDisp = DecToHexStr(60) & "(ASCII)" & Space(5) & "`"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                    End If
                ElseIf vKey = &HDB& Then
                    If KeyStatus(VK_SHIFT) Then
                         KeyDisp = "DB     {"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                    Else
                         KeyDisp = DecToHexStr(91) & "(ASCII)" & Space(5) & "["
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                    End If
                ElseIf vKey = &HDC& Then
                    If KeyStatus(VK_SHIFT) Then
                         KeyDisp = "DC     |"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                    Else
                         KeyDisp = DecToHexStr(92) & "(ASCII)" & Space(5) & "\"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                    End If
                ElseIf vKey = &HDD& Then
                    If KeyStatus(VK_SHIFT) Then
                         KeyDisp = "DD     }"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                    Else
                         KeyDisp = DecToHexStr(93) & "(ASCII)" & Space(5) & "]"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                    End If
                ElseIf vKey = &HDE& Then
                    If KeyStatus(VK_SHIFT) Then
                         KeyDisp = "DE     " & """"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                    Else
                         KeyDisp = DecToHexStr(39) & "(ASCII)" & Space(5) & "'"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                    End If
                ElseIf vKey = &HFF& Then
                    If KeyStatus(VK_SHIFT) Then
                         KeyDisp = "FF     [Fn]"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                         ToggleState VK_SHIFT
                    Else
                         KeyDisp = "[Menu]"
                         lblVirtualKey.Caption = KeyDisp
                         txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                    End If
                Else                     ' We don't know what it will be specifically
                    If KeyStatus(VK_SHIFT) Then
                         ToggleState VK_SHIFT
                    End If
                    KeyDisp = DecToHexStr(vKey) & Space(5) & Chr(vKey)
                    lblVirtualKey.Caption = KeyDisp
                    txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
                End If
            End If
        End If
        DoEvents
    Next vKey
    
    If ckbDetectShiftAlone.Value = 1 Then          ' Checked
        If ShiftOn = False Then
            If GetKeyState(&H10) Then
                 ShiftOn = True
                 KeyDisp = "10     [SHIFT]"
                 GoTo Done
            End If
        Else
            If GetKeyState(&H10) = False Then
                 ShiftOn = False
                 KeyDisp = "10     [SHIFT]"
                 GoTo Done
            End If
        End If
    End If
    
    Exit Sub
    
Done:
    lblVirtualKey.Caption = KeyDisp
    txbKeyHistory = KeyDisp & vbCrLf & txbKeyHistory
    Exit Sub
End Sub


 
Private Function KeyStatus(ByVal inVal As Long) As Boolean
    Dim OSVer As OSVERSIONINFO
    Dim arrKeys(0 To 255) As Byte
    OSVer.dwOSVersionInfoSize = Len(OSVer)
    GetKeyboardState arrKeys(0)
    KeyStatus = arrKeys(inVal)
End Function



Private Function DecToHexStr(ByVal inVal As Integer) As String
    Dim s As String
    s = Trim(Hex(inVal))
    If Len(s) < 2 Then
         s = "0" & s
    End If
    DecToHexStr = s
End Function



' Not used here
Private Sub ToggleState(ByVal inVal As Long)
    Dim arrKeys(0 To 255) As Byte
    GetKeyboardState arrKeys(0)
      ' Note: per MS, SetKeyboardState() is not working OK, avoid using it
    If WinVer = VER_PLATFORM_WIN32_WINDOWS Then         ' Win95/98
         arrKeys(inVal) = 1
         SetKeyboardState arrKeys(1)
    ElseIf WinVer = VER_PLATFORM_WIN32_NT Then          ' WinNT
         keybd_event inVal, &H45, KEYEVENTF_EXTENDEDKEY Or 0, 0
         keybd_event inVal, &H45, KEYEVENTF_EXTENDEDKEY Or KEYEVENTF_KEYUP, 0
    End If
    DoEvents
End Sub





